#include <stdio.h>
#include <stdlib.h>

#define MAXN 302
#define MOD 301
#define H1 1000003
#define H2 2000003
#define H3 8000009
#define base 30011
#define min(a,b) ((a) < (b) ? (a) : (b))
#define rest(a,b) ((a)-(a)/(b)*(b))

typedef long long llong;

int T, N, M, K, A[MAXN][MAXN], H[MAXN][MAXN];
int B[MAXN][MAXN], B2[MAXN][MAXN], mod_b[MAXN], mod_h[MAXN][2];

int *hash[H2];

int insert(int x, int y, int key);

int baga_hash(int P)
{
    int i, j, aux;
    llong x, y;

    for(i = 1; i <= N; i++)
    {
        for(x = 0, j = 1; j <= P; j++)
            x += (llong)A[i][j]*mod_b[P-j], x = rest(x, H1);
        H[i][1] = (int)x;
    }

    for(i = 1; i <= N; i++)
     for(j = 2; j <= M-P+1; j++)
     {
        x = (llong)H[i][j-1] * base + (llong)A[i][j+P-1], x = rest(x, H1);
        y = rest((llong)A[i][j-1]*mod_b[P], H1), x = x-y+H1;
        x = rest(x, H1), H[i][j] = (int)x;
     }

    for(j = 1; j <= M-P+1; j++)
    {
        for(x = y = 0, i = 1; i <= P; i++)
        {
            x += (llong)H[i][j]*mod_h[P-i][0], x = rest(x, H2);
            y += (llong)H[i][j]*mod_h[P-i][1], y = rest(y, H3);
        }
        B[1][j] = (int)x, B2[1][j] = (int)y;
        if( insert(1, j, B[1][j]) )
            return 1;
    }

    for(i = 2; i <= N-P+1; i++)
     for(j = 1; j <= M-P+1; j++)
     {
        x = (llong)B[i-1][j]*H1 + (llong)H[i+P-1][j], x = rest(x, H2);
        y = rest((llong)H[i-1][j]*mod_h[P][0], H2), x = x-y+H2;
        x = rest(x, H2), B[i][j] = (int)x;
        x = (llong)B2[i-1][j]*H1 + (llong)H[i+P-1][j], x = rest(x, H3);
        y = rest((llong)H[i-1][j]*mod_h[P][1], H3), x = x-y+H3;
        x = rest(x, H3), B2[i][j] = (int)x;
        if( insert(i, j, B[i][j]) )
            return 1;
     }
     return 0;
}

int insert(int x, int y, int key)
{
    int i, xx, yy, cnt;
    if( !hash[key] )
        hash[key] = (int*) realloc(hash[key], sizeof(int)), hash[key][0] = 0;
    hash[key][0]++;
    hash[key] = (int*) realloc(hash[key], sizeof(int)*(hash[key][0]+2));
    hash[key][hash[key][0]] = x*MOD+y;
    for(cnt = 1, i = 1; i < hash[key][0]; i++)
    {
        xx = hash[key][i] / MOD, yy = rest(hash[key][i], MOD);
        if(B2[xx][yy] == B2[x][y])
            cnt++;
        if(cnt >= K)
            return 1;
    }
    return 0;
}

void init_modulo(void)
{
    int i;
    llong x;
    for(mod_b[0] = mod_h[0][0] = mod_h[0][1] = 1, i = 1; i <= 300; i++)
    {
        x = (llong)mod_b[i-1]*base, x = rest(x, H1), mod_b[i] = (int)x;
        x = (llong)mod_h[i-1][0]*H1, x = rest(x, H2), mod_h[i][0] = (int)x;
        x = (llong)mod_h[i-1][1]*H1, x = rest(x, H3), mod_h[i][1] = (int)x;
    }
}

int solve(void)
{
    int i, j, st, dr, m, r = 0;

    st = 1, dr = min(N, M);

    while(st <= dr)
    {
        m = (st+dr) >> 1;

        if( baga_hash(m) )
            r = m, st = m+1;
        else
            dr = m-1;

        for(i = 1; i <= N; i++)
         for(j = 1; j <= M; j++)
            hash[B[i][j]] = (int*) realloc(hash[B[i][j]], sizeof(int)),
            hash[B[i][j]][0] = 0;
    }

    return r;
}

void ruleaza(void)
{
    int t, i, j;

    scanf("%d\n", &T);

    init_modulo();
    
    for(t = 1; t <= T; t++)
    {
        scanf("%d %d %d\n", &N, &M, &K);
        for(i = 1; i <= N; i++)
         for(j = 1; j <= M; j++)
            scanf("%d", &A[i][j]), A[i][j]++;
        printf("%d\n", solve());
    }
}

int main(void)
{
    freopen("poze.in", "rt", stdin);
    freopen("poze.out", "wt", stdout);

    ruleaza();

    return 0;
}






