#include <stdio.h>
#include <string>
#include <algorithm>

using namespace std;

#define MAX_N 150005
#define FIN "peg.in"
#define FOUT "peg.out"
#define FOR(i, a, b) for (i = (a); i < (b); i++)
#define bit(a, b) (((a) & (1<<(b))) > 0)
#define INF 166666

int T, N;
char S[MAX_N], ok[1<<20];

int code(void)
{
    int i, n = 0;
    
    FOR (i, 0, N) n += (S[i]-'0')*(1<<i);
    return n;
}

int sclavie(int i)
{
    int j;
    
    if (ok[i] != -1) return ok[i];
    ok[i] = 0;
    if (!(i & (i-1))) { ok[i] = 1; return 1; }
    FOR (j, 0, N-2)
        if (bit(i, j) && bit(i, j+1) && !bit(i, j+2))
           ok[i] |= sclavie(i-(1<<j)-(1<<(j+1))+(1<<(j+2)));
    FOR (j, 2, N)
        if (bit(i, j) && bit(i, j-1) && !bit(i, j-2))
           ok[i] |= sclavie(i-(1<<j)-(1<<(j-1))+(1<<(j-2)));
    return ok[i];
}

int solve(void)
{
    int i, j, k, x, y, ok;
    char s[MAX_N];

    strcpy(s, S);
    for (ok = 1; ok; )
    {
        ok = 0;
        FOR (i, 0, N)
        {
            if (s[i] == '0') continue;
            for (j = i; j < N && s[j] == s[i]; j++);
            if (j == i+1) continue;
            
            if (i-1 < 0 && j >= N) return 0;
            for (x = i-1; x >= 0 && s[x] == '0'; x--);
            for (y = j; y < N && s[y] == '0'; y++);
            if (x < 0) x = INF; else x = i-x;
            if (y >= N) y = INF; else y = y-j+1;
            
            if (j >= N || x < y || (x == y && rand()&1))
            {
               j--;
               for (k = i-1; k+1 < N && k < j; k += 2)
                   s[k] = '1', s[k+1] = '0';
               if ((j-i+1)&1)
                  s[j] = '1', s[j-1] = '0';
               else
                  s[j] = '0';
               ok = 1;
            }
            else
            {
               for (k = j; k > 0 && k > i; k -= 2)
                    s[k] = '1', s[k-1] = '0';
               if ((j-i)&1)
                  s[i] = '1', s[i+1] = '0';
               else s[i] = '0';
               ok = 1;
            }
        }
    }
    int nr = 0;
    FOR (i, 0, N) nr += s[i] == '1';
    return nr <= 1;
}

int main(void)
{
    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    for (scanf("%d\n", &T); T > 0; T--)
    {
        fgets(S, MAX_N, stdin);
        N = strlen(S);
        if (S[N-1] == '\n') S[--N] = 0;

        if (N <= 20)
        {
            memset(ok, -1, sizeof(ok));
            printf("%d\n", sclavie(code()));
            continue;
        }

        if (!solve())
        {
            reverse(S, S+N);
            if (!solve()) printf("0\n");
                     else printf("1\n");
        } else printf("1\n");
    }
    
    return 0;
}
