#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <algorithm>

using namespace std;

#define MAX_N 305
#define MAX_BUF 65536
#define MAX_H 41357 //666013
#define FIN "poze.in"
#define FOUT "poze.out"
#define FOR(i, a, b) for (i = (a); i < (b); ++i)
#define ll int //long long
#define f first
#define s second
#define mp make_pair

int T, N, M, K, A[MAX_N][MAX_N], B[MAX_N][MAX_N], C[MAX_N][MAX_N], base, nv;
char buf[MAX_BUF], *p;
pair<ll, pair<short, short> > V[MAX_N*MAX_N];
int up[MAX_N*MAX_N];

inline int get(void)
{
    int n;
    
    for (n = 0; *p >= '0' && *p <= '9'; p++)
        n = n*10 + *p-'0';
    for (; *p == ' '; p++);
    return n;
}

inline int pow(int a, int b)
{
    int t;
    
    if (!b) return 1;
    t = pow(a, b>>1);
    t = ((ll) t * (ll) t) % MAX_H;
    if (b&1) t = ((ll) t * (ll) a) % MAX_H;
    return t;
}

void process(int a[], int b[], int n, int base, int size)
{
    int i, inv_base = pow(base, MAX_H-2), t = 1;

    b[0] = 0;
    FOR (i, 0, size)
    {
        b[0] = (b[0] + (ll) a[i] * (ll) t) % MAX_H;
        t = ((ll) t * (ll) base) % MAX_H;
    }
    FOR (i, 1, n-size+1)
    {
        b[i] = (b[i-1] + MAX_H - a[i-1]) % MAX_H;
        b[i] = (b[i] + (ll) a[i+size-1] * (ll) t) % MAX_H;
        b[i] = ((ll) b[i] * (ll) inv_base) % MAX_H;
    }
}

inline int cmp(int x1, int y1, int x2, int y2, int size)
{
    int i, j;

    FOR (i, 0, size) FOR (j, 0, size)
        if (A[x1+i][y1+j] != A[x2+i][y2+j]) return 0;
    return 1;
}

int find(int n) { if (n != up[n]) up[n] = find(up[n]); return up[n]; }
inline void reunion(int i, int j) { if (i == j) return; if (rand()&1) up[i] = j; else up[j] = i; }

int works(int size)
{
    int i, j, t, T[MAX_N];

    FOR (i, 0, N) process(A[i], B[i], M, base, size);
    t = pow(base, size);
    FOR (i, 0, M-size+1)
    {
        FOR (j, 0, N) T[j] = B[j][i];
        process(T, C[i], N, t, size);
    }

    nv = 0;
    FOR (i, 0, M-size+1) FOR (j, 0, N-size+1)
        V[nv++] = mp(C[i][j], mp(j, i));
    sort(V, V+nv);

    FOR (i, 0, nv) up[i] = i;
    FOR (i, 0, nv)
    {
        for (j = i+1, t = 1; j < nv && V[j].f == V[i].f && t < K; j++)
            if (find(i) == find(j) || cmp(V[i].s.f, V[i].s.s, V[j].s.f, V[j].s.s, size))
            {
               t++;
               reunion(find(i), find(j));
            }
        if (t >= K)
            return 1;
    }
    
    return 0;
}

int main(void)
{
    int i, j, inc;
    
    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    base = 30103;

    for (scanf("%d\n", &T); T > 0; T--)
    {
        scanf("%d %d %d\n", &N, &M, &K);
        FOR (i, 0, N)
        {
            fgets(buf, MAX_BUF, stdin);
            p = buf;
            FOR (j, 0, M) { A[i][j] = get(); A[i][j]++; }
        }

        for (inc = 1; inc < N && inc < M; inc <<= 1);
        for (i = 0; inc; inc >>= 1)
            if (i+inc < N && i+inc < M && works(i+inc)) i += inc;

        printf("%d\n", i);
    }
    
    return 0;
}
