#include <ctype.h>
#include <stdio.h>
#include <string.h>

#define FIN "poze.in"
#define FOUT "poze.out"

#define MAX_N 300
#define MAX_L 10000

typedef struct
{
    int i, j;
} Entry;

Entry *a, *b, E[MAX_N * MAX_N];
int N, M, K, A[MAX_N][MAX_N], BH[MAX_N * MAX_N];

void parse(int L)
{
    int n, q;
	char line[MAX_L], *p;

    fgets(line, MAX_L, stdin), p = line;
	for (n = 0; *p; A[L][n++] = q)
	{
	    for (; *p && !isdigit(*p); p++) ;
		for (q = 0; *p && isdigit(*p); p++) q = (q * 10) + (*p) - '0';
	}
}

inline int cmp(const void *i, const void *j)
{
	a = (Entry *) i, b = (Entry *) j;
    return A[a->i][a->j] - A[b->i][b->j];
}

void eliminate(int *N, const int add, const int R, const int C)
{
    int i, n = 0;

	for (i = 0; i < *N; i++)
	    if (E[i].i + add < R && E[i].j + add < C)
		    E[n] = E[i], BH[n] = BH[i], n++;
	*N = n;
}

inline void swap(int *a, int *b)
{
    int tmp = *a;
	*a = *b, *b = tmp;
}

int lower(Entry X, Entry Y, const int add)
{
    int i0 = X.i, j0 = X.j, i1 = Y.i, j1 = Y.j, i;

	for (i = 0; i < add; i++)
	    if (A[i0 + i][j0 + add] < A[i1 + i][j1 + add]) return 1;
		else if (A[i0 + i][j0 + add] > A[i1 + i][j1 + add]) return 0;
	for (i = 0; i <= add; i++)
	    if (A[i0 + add][j0 + i] < A[i1 + add][j1 + i]) return 1;
		else if (A[i0 + add][j0 + i] > A[i1 + add][j1 + i]) return 0;
	return 0;
}

int diff(Entry X, Entry Y, const int add)
{
    int i0 = X.i, j0 = X.j, i1 = Y.i, j1 = Y.j, i;

	for (i = 0; i <= add; i++)
	    if (A[i0 + i][j0 + add] != A[i1 + i][j1 + add]) return 1;
	for (i = 0; i <= add; i++)
	    if (A[i0 + add][j0 + i] != A[i1 + add][j1 + i]) return 1;
	return 0;
}

void bubble_sort(const int add, int L, int R)
{
    int ordo = 0, i;

	for (; !ordo; )
	{
	    for (ordo = 1, i = L; i < R; i++)
		    if (lower(E[i + 1], E[i], add))
			{
			    swap(&E[i].i, &E[i + 1].i);
				swap(&E[i].j, &E[i + 1].j);
				ordo = 0;
			}
	}
	for (i = L; i < R; i++)
	    if (diff(E[i], E[i + 1], add)) BH[i + 1] = 1;
}

int good(int n)
{
	int i, j;

	for (i = 0; i < n; i = j)
	{
	    for (j = i + 1; j < n && !BH[j]; j++) ;
	    if (j - i >= K) return 1;
	}
	return 0;
}

int solve(void)
{
	int i, j, k, n;

	for (i = n = 0; i < N; i++)
	    for (j = 0; j < M; j++)
		    E[n].i = i, E[n++].j = j;
	qsort(E, n, sizeof(Entry), cmp);
    memset(BH, 0, sizeof(BH)), BH[0] = 1;
	for (i = 1; i < n; i++)
	    if (A[E[i - 1].i][E[i - 1].j] != A[E[i].i][E[i].j]) BH[i] = 1;
    if (!good(n)) return 0;
	for (i = 1; i < N; i++)
	{
        eliminate(&n, i, N, M);
		for (j = 0; j < n; j = k)
		{
		    for (k = j + 1; k < n && !BH[k]; k++) ;
			bubble_sort(i, j, k - 1);
		}
	    if (!good(n)) return i;
	}
	return i;
}

int main(void)
{
	int i, tests;

	freopen(FIN, "r", stdin);
	freopen(FOUT, "w", stdout);

	scanf("%d\n", &tests);
	while (tests--)
	{
	    scanf("%d %d %d\n", &N, &M, &K);
		for (i = 0; i < N; i++) parse(i);
		printf("%d\n", solve());
	}

	return 0;
}
