#include<stdio.h>
#include<stdlib.h>

#define MIN(x, y) ((x)<(y)?(x):(y))
#define MAX(x, y) ((x)>(y)?(x):(y))

#define MAXN 302

#define HM1 1101967
#define HM2 1999993

#define HT1 1499977
#define HT2 1199999
#define HTP1 13
#define HTP2 7

int nrp[305], nrpn;
int hlin[MAXN][MAXN];
int mat[MAXN][MAXN];
int n, m, k;

int ch1[MAXN][MAXN], ch2[MAXN][MAXN];

int size;

struct li
{
   int x, y;
   li* next;
};
li *ht1[HT1], *ht2[HT2];
int con_ht1[HT1], con_ht2[HT2];


// return nr^put
unsigned int pow(int nr, int put)
{
   if (put==0) return 1;
   unsigned int res=nr;
   for (int i=2; i<put; ++i) res*=nr;
   return res;
}

// hash-per-column functions
int hashc1(int i, int j)
{
   int hash1=0;
   for (int l=0; l<size; ++l)
      hash1 = (unsigned int) (mat[i+l][j] * nrp[l] + hash1) % HM1;
   return hash1;
}
int hashc2(int i, int j)
{
   int hash2=0;
   for (int l=0; l<size; ++l)
      hash2 = (unsigned int) (mat[i+l][j] * nrp[l] + hash2) % HM2;
   return hash2;
}

// insert into hash table
void ins(int i, int j, int h1, int h2)
{
   li *a;
   a = (li *) malloc(sizeof(li));
   a->x = i; a->y = j;
   a->next = ht1[h1]; ht1[h1] = a;
   ++con_ht1[h1];

   a = (li *) malloc(sizeof(li));
   a->x = i; a->y = j;
   a->next = ht2[h2]; ht2[h2] = a;
   ++con_ht2[h2];

   ch1[i][j] = h1; ch2[i][j] = h2;
}

inline void free_hash()
{
   int h;
   for (int i=0; i<n-size+1; ++i)
      for (int j=0; j<m-size+1; ++j)
      {
         h = ch1[i][j];
         for (li* a = ht1[h], *b; a!=NULL;)
         {
            b=a; a = a->next;
            free(b);
         }
         ht1[h] = NULL; con_ht1[h] = 0;

         h = ch2[i][j];
         for (li* a = ht2[h], *b; a!=NULL;)
         {
            b=a; a = a->next;
            free(b);
         }
         ht2[h] = NULL; con_ht2[h] = 0;
      }
}


int max_size=0;
bool incearca()
{
   int i, j;
   int htc1, htc2;
   
   // insert elements into hash tables
   for (i=0; i<n-size+1; ++i)
   {
      htc1 = htc2 = 0;
      for (j=0; j<size; ++j)
      {
         htc1 = (unsigned int) (htc1 * HTP1 + hashc1(i, j)) % HT1;
         htc2 = (unsigned int) (htc2 * HTP2 + hashc2(i, j)) % HT2;
      }
      ins(i, 0, htc1, htc2);
      for (j=size; j<m; ++j)
      {
         htc1 = (unsigned int) htc1 - hashc1(i, j-size)*pow(HTP1,size-1);
         if (htc1<0) htc1+=HT1;
         htc2 = (unsigned int) htc2 - hashc2(i, j-size)*pow(HTP2,size-1);
         if (htc2<0) htc2+=HT2;
         
         htc1 = (unsigned int) (htc1 * HTP1 + hashc1(i, j)) % HT1;
         htc2 = (unsigned int) (htc2 * HTP2 + hashc2(i, j)) % HT2;
         ins(i, j-size+1, htc1, htc2);
      }
   }

   li *a, *b;
   bool found;
   int con=0;

   for (i=0; i<n-size+1; ++i)
      for (j=0; j<m-size+1; ++j)
      {
         htc1 = ch1[i][j]; htc2 = ch2[i][j]; con = 0;

//         if (con_ht1[htc1] != con_ht2[htc2]) printf("!"); // DEBUG-statistical info

         // compare hash entries
         if (MIN(con_ht1[htc1], con_ht2[htc2]) < k) continue;

         if (con_ht1[htc1] < con_ht2[htc2])
            a = ht1[htc1], b = ht2[htc2];
         else a = ht2[htc2], b = ht1[htc1];

         for (; a!=NULL; a=a->next)
         {
            found = false;
            for (; b!=NULL; b=b->next)
               if (a->x == b->x && a->y == b->y)
               {
                  found = true;
                  break;
               }
            con += found;
            if (con>=k)
            {
               max_size = MAX(max_size, size);
               return true;
            }
         }
      }

   return false;
}

bool go()
{
   bool res = incearca();
   free_hash();
   return res;
}

int is_prime(int nr)
{
   for (int i=2; i*i<=nr; ++i)
      if (nr%i == 0) return 0;
   return 1;
}

int main(void)
{
   freopen("poze.in", "rt", stdin);
   freopen("poze.out", "wt", stdout);

   int i, j;

   // generate prime numbers
   for (i=2; i<2000; ++i)
      if (is_prime(i)) nrp[nrpn++] = i;


   int tn;
   scanf("%d", &tn);
   for (int tc=0; tc<tn; ++tc)
   {
      scanf("%d%d%d", &n, &m, &k);
      for (i=0; i<n; ++i)
         for (j=0; j<m; ++j)
            scanf("%d", &mat[i][j]);

      // binary search for size
      int ll=0, lr=MIN(n, m), lm;
      while (ll<=lr)
      {
         lm = (ll+lr)/2;

         size = lm;
         if (go()) ll = lm+1;
         else lr = lm-1;
      }

      printf("%d\n", max_size);
      max_size = 0;
   }
   
   return 0;
}

