#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <vector>
using namespace std;

#define FOR(i, a, b) for (i = (a); i <= (b); i ++)
#define REP(i, n)    for (i =   0; i <  (n); i ++)
#define FORI(i, x)   for (i = (x).begin(); i != (x).end(); i ++)
#define pb push_back

#define NMAX 205

int e1[NMAX], e2[NMAX], w[NMAX], good[NMAX], seen[NMAX];
int N, M, K, i, j, k, stp, P;
vector<int> adj[NMAX];
int a[NMAX][NMAX], b[NMAX], node[NMAX], edge[NMAX];
char color[NMAX];

void read(void)
{
    freopen("bcolor.in", "r", stdin);
    freopen("bcolor.out", "w", stdout);
    scanf("%d %d %d", &N, &M, &K);
    for (i = M; i >= 1; i --)
    {
        scanf("%d %d %d", &e1[i], &e2[i], &w[i]);
        adj[e1[i]].pb(e2[i]), adj[e2[i]].pb(e1[i]);
        color[i] = 'A';
        if (w[i] == 2) color[i] = 'R';
    }
}

void dfs(int x)
{
    vector<int> :: iterator it;
    seen[x] = 1;
    FORI(it, adj[x])
        if (!seen[*it])
            dfs(*it);
}

#define SWAP(x, y) ((x) ^= (y) ^= (x) ^= (y))
void swp_line(int x, int y)
{
    int i;
    FOR(i, 1, M)
        SWAP(a[x][i], a[y][i]);
    SWAP(b[x], b[y]);
    SWAP(node[x], node[y]);
}

void add_line(int x, int y)
{
    int i;
    FOR(i, 1, M)
        a[y][i] ^= a[x][i];
    b[y] ^= b[x];
}

int count(void) //-1 pt 0 solutii
{
    int ret, i;
    if (N > P)
    {
        FOR(i, P + 1, N)
            if (b[i]) return -1;
    }

    ret = 0;
    if (P > N) ret = P - N;

    //rezolvam sistemul
    int min = N < P ? N : P;
    FOR(i, 1, min)
        if (a[i][i] == 0)
            ++ ret;

    return ret;
}

void sistem(void)
{
    memset(seen, 0, sizeof(seen));
    memset(good, 0, sizeof(good));
    memset(b, 0, sizeof(b));
    dfs(1);
    FOR(i, 1, M)
    {
        if (seen[e1[i]] && seen[e2[i]])
            good[i] = 1;
//        if (w[i] == 2)
//            b[e1[i]] ^= 1, b[e2[i]] ^= 1;
    }

    int X = 0;
    memset(a, 0, sizeof(a));
    FOR(i, 1, N)
        if (seen[i])
        {
            ++ X;
            node[X] = i, P = 0;
            FOR(j, 1, M)
                if (w[j] == 0 && good[j])
                {
                    edge[++ P] = j;
                    if (e1[j] == i || e2[j] == i)
                        a[X][P] = 1;
                }
        }
        
    FOR(i, 1, M)
        if (w[i] == 2)
        {
            FOR(j, 1, N)
                if (node[j] == e1[i] || node[j] == e2[i])
                    b[j] ^= 1;
       }
        
    N = X;
    int min = N < P ? N : P;
    FOR(stp, 1, min)
    {
        FOR(k, stp, N)
            if (a[k][stp] == 1)
            {
                if (stp != k)
                    swp_line(stp, k);
                break;
            }

        if (a[stp][stp] == 1)
        {
            FOR(k, stp + 1, N)
                if (a[k][stp] == 1)
                    add_line(stp, k);
        }
    }
}

void solve(void)
{
    while (P >= 1)
    {
        -- P;
        color[edge[P + 1]] = 'A';

        int x = count(), nr;
        if (x == -1)
            nr = 0;
        else
            nr = x > 27 ? 100000000 : 1 << x;
        
        if (K > nr)
        {
            K -= nr;
            color[edge[P + 1]] = 'R';
            FOR(i, 1, N)
                if (a[i][P + 1])
                    b[i] ^= 1;
        }

        FOR(i, 1, N) a[i][P + 1] = 0; //nu mai intra in sistem
    }

    for (i = M; i >= 1; i --)
        printf("%c", color[i]);
    printf("\n");
}

void gen(void)
{
    freopen("bcolor.in", "w", stdout);
    int i, j, k;
    N = 40, M = 200, K = 1;
    memset(a, 0, sizeof(a));
    FOR(k, 1, M)
    {
        do {
        i = 1 + rand() % N;
        j = 1 + rand() % N;
        } while (i == j || a[i][j] == 1);
        a[i][j] = 1;
    }

    printf("%d %d %d\n", N, M, K);
    FOR(i, 1, N)
        FOR(j, 1, N)
            if (a[i][j])
                printf("%d %d %d\n", i, j, 0);
}

int main(void)
{
    read();
    color[0] = '#';
    sistem();
    solve();
    return 0;
}
