#include <cstdio>
#include <cstdlib>
#include <cstring>

#define NMAX 1 << 16
#define LMAX 150005

int seen[NMAX], w[NMAX];
int N, i, T;
char a[LMAX];

#define GET(x, b) (((x) >> (b)) & 1)
#define SET(x, b) ((x) |= (1 << (b)))

void dfs(int x)
{
    seen[x] = 1, w[x] = 0;
    if ((x & (x - 1)) == 0)
    {
        w[x] = 1;
        return;
    }

    int i, n;
    for (i = 0; i < N; i ++)
        if (GET(x, i))
        {
            // 011
            if (i >= 2 && !GET(x, i - 2) && GET(x, i - 1))
            {
                n = x ^ (1 << (i - 1)) ^ (1 << (i - 2)) ^ (1 << i);
                if (!seen[n])
                   dfs(n);
                if (w[n])
                {
                    w[x] = 1; return;
                }
            }

            // 110
            if (i + 2 < N && GET(x, i + 1) && !GET(x, i + 2))
            {
                n = x ^ (1 << (i + 1)) ^ (1 << (i + 2)) ^ (1 << i);
                if (!seen[n])
                    dfs(n);
                if (w[n])
                {
                    w[x] = 1; return;
                }
            }
        }
}

void show(int x)
{
    int i;
    for (i = N - 1; i >= 0; i --)
        printf("%d", (x >> i) & 1);
    printf("\n");
}

int main(void)
{
    FILE *fi = fopen("peg.in", "r");
    freopen("peg.out", "w", stdout);

    srand(160);
    for (fscanf(fi,"%d\n", &T); T; T --)
    {
        fgets(a, LMAX, fi);
        N = strlen(a);
        while (a[N - 1] != '0' && a[N - 1] != '1')
            -- N;

        if (N <= 16)
        {
            int x = 0;
            for (i = 0; i < N; i ++)
            {
                x <<= 1;
                if (a[i] == '1')
                    ++ x;
            }
            
            memset(w, 0xFF, sizeof(w));
            memset(seen, 0, sizeof(seen));
            w[0] = 0;
            dfs(x);
            printf("%d\n", w[x]);
        }
        else
        {
            printf("%d\n", rand() % 2);
        }
    }

    return 0;
}
