using namespace std;

#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <algorithm>

#define FIN  "poze.in"
#define FOUT "poze.out"

#define MAX_N 305
#define MAX_C 30010

#define MOD 363123157

int T, N, M, K, ans;
int A[MAX_N][MAX_N], C[MAX_N][MAX_N], ***S;
char e[MAX_N][MAX_N];
int maxval[MAX_N];

void shift(int sx, int sy)
{
	int i, j, xmin, xmax, ymin, ymax;
	xmin = max(1, 1+sx)-sx;
	xmax = min(M, M+sx)-sx;
	ymin = max(1, 1+sy)-sy;
	ymax = min(N, N+sy)-sy;

	for (i = xmin; i <= xmax; ++i)
		for (j = ymin; j <= ymax; ++j)
			e[i][j] = (A[i][j] == A[i+sx][j+sy]);
	memset(C, 0, sizeof(C));
	for (i = xmax; i >= xmin; --i)
		for (j = ymax; j >= ymin; --j) {
			C[i][j] = min(C[i+1][j], C[i][j+1]);
			if ((C[i][j+1] == C[i+1][j] || C[i][j] == 0) && 
					e[i+C[i][j]][j+C[i][j]] == 1)
				C[i][j]++;
			S[i][j][C[i][j]]++;
		}
}

void solve()
{
	int i, j, l;
	
	S = (int***)calloc(N+1, sizeof(int**));
	for (i = 1; i <= N; ++i) {
		S[i] = (int**)calloc(M+1, sizeof(int*));
		for (j = 1; j <= M; ++j)
			S[i][j] = (int*)calloc(min(N, M)+2, sizeof(int));
	}
	
	memset(S, 0, sizeof(S));
	for (i = 0; i < N; ++i)
		for (j = -M+1; j <= M-1; ++j)
			shift(i, j);
	memset(maxval, 0, sizeof(maxval));
	for (i = 1; i <= N; ++i)
		for (j = 1; j <= M; ++j)
			for (l = min(N, M)-1; l >= 0; --l) {
				S[i][j][l] += S[i][j][l+1];
				if (S[i][j][l] > maxval[l])
					maxval[l] = S[i][j][l];
			}
	for (ans = 0; ans+1 <= min(N, M) && maxval[ans+1] >= K; ++ans);
}

void write()
{
	printf("%d\n", ans);
}

int main()
{
	freopen(FIN, "r", stdin);
	freopen(FOUT, "w", stdout);

	int i, j;
	
	for (scanf("%d", &T); T--; ) {
		scanf("%d%d%d", &N, &M, &K);
		for (i = 1; i <= N; ++i)
			for (j = 1; j <= M; ++j) {
				scanf("%d", A[i]+j);
				A[i][j]++;
			}
		solve();
		write();
	}
	return 0;
}
