#include <stdio.h>

#define MAXN (1 << 17)
#define INF (1 << 29)

typedef long long llong;

typedef struct point { int x, y, y2; } point;

int N;
point A[MAXN];

int cross(point A, point B, point C)
{
    llong res;
    res = (llong)(B.x-A.x)*(C.y-A.y)-(llong)(B.y-A.y)*(C.x-A.x);
    if(res > 0) return 1;
    if(res == 0) return 0;
    return (-1);
}

point first, second;

int check(point X, point Y)
{
    int i;
    point AUX1, AUX2;

    for(i = 1; i <= N; i++)
    {
        AUX1.x = AUX2.x = A[i].x, AUX1.y = A[i].y, AUX2.y = A[i].y2;
        if( cross(X, AUX1, Y) * cross(X, AUX2, Y) > 0 )
            return i;
    }

    return 0;
}

int A1, A2, B1, B2, ind;

void solve(void)
{
    int i, x, y, t, st, dr, m;
    point aux, X, Y;
    
    first = A[1], ind = 1;

    for(i = 2; i <= N; i++)
        if(A[i].y2-A[i].y < first.y2-first.y)
            first = A[i], ind = i;

    for(second.y2 = INF, i = 1; i <= N; i++)
        if((A[i].y2-A[i].y < second.y2-second.y) && (A[i].x != A[ind].x))
            second = A[i];
            
    X.x = first.x, Y.x = second.x;
    for(i = first.y; i <= first.y2; i++)
    {
        X.y = i, st = second.y, dr = second.y2;
        while(st <= dr)
        {
            Y.y = m = (st+dr) >> 1;
            if( (t = check(X, Y)) == 0 )
            {
                A1 = first.x, A2 = second.x, B1 = i, B2 = m;
                return ;
            }
            if( cross(X, A[t], Y) > 0 ) // deasupra
                st = m+1;
            else
                dr = m-1;
        }
    }
}

void read_data(void)
{
    int i, ind, nr;
    char sir[1024];
    scanf("%d\n", &N);

    for(i = 1; i <= N; i++)
    {
        fgets(sir, 1024, stdin), ind = 0;
        for(nr = 0; sir[ind] >= '0' && sir[ind] <= '9'; ind++)
            nr = nr*10 + (sir[ind]-48);
        A[i].x = nr;
        for(ind++, nr = 0; sir[ind] >= '0' && sir[ind] <= '9'; ind++)
            nr = nr*10 + (sir[ind]-48);
        A[i].y = nr;
        for(ind++, nr = 0; sir[ind] >= '0' && sir[ind] <= '9'; ind++)
            nr = nr*10 + (sir[ind]-48);
        A[i].y2 = nr;
    }
}

void write_data(void)
{
    printf("%d %d %d %d\n", A1, B1, A2, B2);
}
    
int main(void)
{
    freopen("oypara.in", "rt", stdin);
    freopen("oypara.out", "wt", stdout);

    read_data();
    solve();
    write_data();

    return 0;
}









    
    

    


    



