#include <stdio.h>
#include <string.h>

#define MAXN 128
#define MAXC 256
#define base 10000
#define display "%04d"

typedef int num[MAXC];

int N, type;

num T[MAXN][2], SOL;

void add(num A, num B)
{
    int i, t = 0;
    for(i = 1; i <= A[0] || i <= B[0] || t; i++, t /= base)
        A[i] = (t += A[i]+B[i]) % base;
    A[0] = i-1;
}

void mul(num A, num B)
{
    int i, j, t;
    num C;
    memset(C, 0, sizeof(C));
    for(i = 1; i <= A[0]; i++)
    {
        for(j = 1, t = 0; j <= B[0] || t; j++, t /= base)
            C[i+j-1] = (t += C[i+j-1]+A[i]*B[j]) % base;
        if(i+j-2 > C[0]) C[0] = i+j-2;
    }
    memcpy(A, C, sizeof(C));
}

void sub(num A, num B)
{
    int i, t = 0;
    for(i = 1; i <= A[0]; i++)
    {
        A[i] = A[i]-B[i]-t;
        if(A[i] < 0) A[i] += base, t = 1;
        else t = 0;
    }
    for(; !A[A[0]] && A[0] > 1; A[0]--);
}

num AUX, B1, B2;

void solve(void)
{
    int i;

    T[1][1][0] = T[1][1][1] = T[2][1][0] = T[2][1][1] = 1;
    T[2][0][0] = T[2][0][1] = T[1][0][0] = 1;

    for(i = 3; i <= N+1; i++)
    {
        T[i][1][0] = 1, add(T[i][1], T[i-2][1]), add(T[i][1], T[i-2][0]);
        add(T[i][1], T[i-1][0]);
        T[i][0][0] = 1, add(T[i][0], T[i-2][1]), add(T[i][0], T[i-2][0]);
    }
    if(type == 1) // pentru A
    {
        memcpy(SOL, T[N][1], sizeof(num)), add(SOL, T[N][0]);
        for(printf("%d", SOL[SOL[0]]), i = SOL[0]-1; i >= 1; i--)
            printf(display, SOL[i]);
        printf("\n");
    }
    if(type == 2) // pentru B
    {
        if(N == 1)
            printf("2\n");
        else
        {
            memcpy(AUX, T[N-1][1], sizeof(num)), add(AUX, T[N-1][0]);
            mul(AUX, AUX), add(AUX, AUX);
            memcpy(SOL, T[N-1][1], sizeof(num)), add(SOL, T[N-1][0]);
            mul(SOL, T[N][0]), add(SOL, SOL), add(SOL, AUX);
            for(printf("%d", SOL[SOL[0]]), i = SOL[0]-1; i >= 1; i--)
                printf(display, SOL[i]);
            printf("\n");
        }
    }
    if(type == 3) // pentru C
    {
        if(N == 1)
            printf("2\n");
        else
        {
            memcpy(AUX, T[N-1][1], sizeof(num)), add(AUX, T[N-1][0]);
            mul(AUX, AUX), add(AUX, AUX);
            memcpy(SOL, T[N-1][1], sizeof(num)), add(SOL, T[N-1][0]);
            mul(SOL, T[N][0]), add(SOL, SOL), add(SOL, AUX);
            memcpy(B2, SOL, sizeof(SOL));

            memcpy(AUX, T[N][1], sizeof(num)), add(AUX, T[N][0]);
            mul(AUX, AUX), add(AUX, AUX);
            memcpy(SOL, T[N][1], sizeof(num)), add(SOL, T[N][0]);
            mul(SOL, T[N+1][0]), add(SOL, SOL), add(SOL, AUX);
            memcpy(B1, SOL, sizeof(SOL));

            sub(B1, B2);

            for(printf("%d", B1[B1[0]]), i = B1[0]-1; i >= 1; i--)
                printf(display, B1[i]);
            printf("\n");
        }
    }
}




int main(void)
{
    char c;

    freopen("perfect.in", "rt", stdin);
    freopen("perfect.out", "wt", stdout);

    scanf("%c %d\n", &c, &N);

    if(c == 'A')
        type = 1;

    if(c == 'B')
        type = 2;

    if(c == 'C')
        type = 3;

    solve();
    
    return 0;
}


