#include <stdio.h>
#include <math.h>
#include <stdlib.h>

FILE *f = fopen("oypara.in", "r");
FILE *g = fopen("oypara.out", "w");

long const nmax = 100010;

struct punct {
	long x, y;
};

struct segment {
	long x, y1, y2;
};

long n, np, ymij, xmij;
segment seg[nmax];
punct p[2*nmax], alfa, beta;
double arctg[2*nmax];

void citeste();
int dir(long x1, long y1, long x2, long y2, long x3, long y3);
double modul(double x);
long modu(long x);
int fcmp(const void *a, const void *b);
void solve();
void scrie();
int verif(long i, long j);

int main() {
	citeste();
	solve();
	scrie();
	fclose(f);
	fclose(g);
	return 0;
}

void citeste() {
	long i, sumay, sumax;
	
	fscanf(f, "%ld", &n);
	np = 0;
	sumay = 0;
	sumax = 0;
	for(i=1; i<=n; i++) {
		fscanf(f, "%ld%ld%ld", &(seg[i].x), &(seg[i].y1), &(seg[i].y2));
		sumay += seg[i].y1 + seg[i].y2;
		sumax += seg[i].x;
		np++;
		p[np].x = seg[i].x;
		p[np].y = seg[i].y1;
		np++;
		p[np].x = seg[i].x;
		p[np].y = seg[i].y2;
	}
	ymij = (long) (sumay / (2*n));
	xmij = (long) (sumax / n);
	
	alfa = p[np/3];
	beta = p[(2*np)/3];
	qsort(p+1, np, sizeof(punct), fcmp);
}

int dir(long x1, long y1, long x2, long y2, long x3, long y3) {
	long long det;

	det = ((long long)(x1 - x2)) * (y3 - y2);
	det -= ((long long)(x3 - x2)) * (y1 - y2);
	if( det < 0) return -1;
	if( det > 0) return 1;
	return 0;
}

double modul(double x) {
	if(x < 0) return (-x);
	return x;
}

long modu(long x) {
	if( x < 0 ) return (-x);
	return x;
}

int fcmp(const void *a, const void *b) {
	punct p1 = *((punct*)a);
	punct p2 = *((punct*)b);
	double arc1, arc2;

	if(p1.y==ymij) return -1;
	if(p2.y==ymij) return 1;

	arc1 = modu(p1.y - ymij) / modu(p1.x - xmij);
	arc2 = modu(p2.y - ymij) / modu(p2.x - xmij);
	if(arc1 < arc2) return -1;
	if(arc1 > arc2) return 1;
	return 0;
}

void solve() {
	long i, j, lim1, lim2;

	lim1 = sqrt((90000000 / np));
	lim2 = lim1 + 1;
	if(lim1 > np ) lim1 = np;
	if(lim2 > np ) lim2 = np;
	for(i=1; i<=lim1; i++)
		for(j=1; j<=lim2; j++)
			if(i!=j && verif(i, j)==1) {
				alfa = p[i];
				beta = p[j];
				return;
			}
}

void scrie() {
	fprintf(g, "%ld%c%ld%c%ld%c%ld\n", alfa.x, ' ', alfa.y, ' ', beta.x, ' ', beta.y);
}

int verif(long i, long j) {
	long k, dir1, dir2;

	for(k=1; k<=n; k++) {
		dir1 = dir(p[i].x, p[i].y, p[j].x, p[j].y, seg[k].x, seg[k].y1);
		dir2 = dir(p[i].x, p[i].y, p[j].x, p[j].y, seg[k].x, seg[k].y2);
		if(dir1!=0 && dir2!=0) {
			if(dir1 > 0 && dir2 > 0) return 0;
			if(dir1 < 0 && dir2 < 0) return 0;
		}
	}
	return 1;
}

