#include <stdio.h>
#include <stdlib.h>

#define MAXN 100010

typedef struct t_segment
{
	int x, y0, y1;
} segment;

void read(void);
int ok(int x0, int y0, int x1, int y1);
int cmp(const void *k1, const void *k2);

int N;
segment S[MAXN];

int main(void)
{
	int i, j;

	freopen("oypara.in", "r", stdin);
    freopen("oypara.out", "w", stdout);

    read();

    qsort(S, N, sizeof(segment), cmp);

	for (i = 0; i < N; i++)
    	for (j = i + 1; j < N; j++)
        {
        	if (ok(S[i].x, S[i].y1, S[j].x, S[j].y0))
            {
            	printf("%d %d %d %d", S[i].x, S[i].y1, S[j].x, S[j].y0);

                return 0;
            }

            if (ok(S[i].x, S[i].y1, S[j].x, S[j].y1))
            {            
            	printf("%d %d %d %d", S[i].x, S[i].y1, S[j].x, S[j].y1);

                return 0;
            }
        }

	return 0;
}

void read(void)
{
	int i, aux;

	scanf("%d", &N);

    for (i = 0; i < N; i++)
    {
    	scanf("%d %d %d", &S[i].x, &S[i].y0, &S[i].y1);
        if (S[i].y0 > S[i].y1)
        	aux = S[i].y0, S[i].y0 = S[i].y1, S[i].y1 = aux;
	}
}

int ok(int x0, int y0, int x1, int y1)
{
	int i;
    long long d1, d2;

    for (i = 0; i < N; i++)
    {
    	d1 = (long long)  (x1 - x0) * (S[i].y0 - y0) - (S[i].x - x0) * (y1 - y0);
    	d2 = (long long)  (x1 - x0) * (S[i].y1 - y0) - (S[i].x - x0) * (y1 - y0);
		if ((d1 && d2) && ((d1 < 0 && d2 < 0) || (d1 > 0 && d2 > 0)))
        	return 0;
    }

	return 1;
}

int cmp(const void *k1, const void *k2)
{
	segment *a1 = (segment *) k1, *a2 = (segment *) k2;

    return (a1 -> y1 - a1 -> y0) - (a2 -> y1 - a2 -> y0);
}
