#include <stdio.h>
#include <stdlib.h>
#include <algorithm>

using namespace std;

#define MAX_N 225
#define FIN "import.in"
#define FOUT "import.out"
#define FOR(i, a, b) for (i = (a); i < (b); i++)
#define INF 100000

struct road
{
    int sz, n[MAX_N], type, val;
} R[MAX_N*MAX_N];

int N, M, K, up[MAX_N], G[MAX_N][MAX_N], deg[MAX_N], nroad, P[MAX_N];
int perm[MAX_N], lim;

void DFS(int n)
{
    int i;
    
    FOR (i, 0, deg[n])
        if (G[n][i] != up[n])
        {
            up[G[n][i]] = n;
            DFS(G[n][i]);
        }
}

void get_road(int idx, int a, int b)
{
    int n;
    road *r = &R[idx];
    
    for (n = a; n != 1; n = up[n])
    {
        r->n[r->sz++] = n;
    }
    r->n[r->sz++] = 1;
    for (n = b; n != 1; n = up[n])
    {
        r->n[r->sz++] = n;
    }
}

int ok(void)
{
    int i, j, t;

    FOR (i, 0, nroad)
    {
        t = 0;
        FOR (j, 0, R[i].sz) t += P[R[i].n[j]];
        if (R[i].type == 0 && t < R[i].val) return 0;
        if (R[i].type == 1 && t > R[i].val) return 0;
    }
    return 1;
}

void bkt(int n)
{
    int i;
    
    if (n == N+1)
    {
        if (!ok()) return;
        FOR (i, 1, N) printf("%d ", P[i]);
        printf("%d\n", P[N]);
        exit(0);
    }

    FOR (i, -lim, lim+1)
    {
        P[perm[n]] += i;
        bkt(n+1);
        P[perm[n]] -= i;
    }
}

int main(void)
{
    int i, a, b, c, d;
    
    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    scanf("%d %d %d", &N, &M, &K);
    FOR (i, 1, N) { scanf("%d %d", &a, &b); G[a][deg[a]++] = b; G[b][deg[b]++] = a; }

    DFS(1);

    for (; M > 0; M--, nroad++)
    {
        scanf("%d %d %d %d", &a, &b, &c, &d);
        get_road(nroad, a, b);
        R[nroad].val = c-d;
        R[nroad].type = d;
        P[rand()&1 ? a : b] = c-d;
        if (lim < c-d) lim = c-d;
           
    }

    FOR (i, 2, N+1) perm[i] = i;
    random_shuffle(perm+2, perm+N+1);
    
    bkt(2);

    return 0;
}
