#include <stdio.h>
#include <stdlib.h>
#include <algorithm>
#include <map>

using namespace std;

#define MAX_N 100005
#define MAX_BUF 65536
#define FIN "oypara.in"
#define FOUT "oypara.out"
#define FOR(i, a, b) for (i = (a); i < (b); i++)
#define x first
#define y1 second.first
#define y2 second.second
#define ll long long
#define mp make_pair
#define sqr(x) ((ll) (x) * (ll) (x))

struct entry
{
    int x, y, sgn;
    bool operator < (entry e) const
    {
        ll a = (ll) e.x * (ll) y, b = (ll) e.y * (ll) x;

        if (a != b) return a < b;
        a = sqr(x) + sqr(y);
        b = sqr(e.x) + sqr(e.y);
        return a < b;
    }
} E[MAX_N<<1];

int N, ne; char buf[MAX_BUF], *p;
pair< int, pair<int, int> > A[MAX_N];
map<int, bool> H;

inline int get(void)
{
    int n;

    for (n = 0; *p >= '0' && *p <= '9'; p++)
        n = n*10 + *p-'0';
    for (; *p == ' '; p++);
    return n;
}

void dump(int x, int y, int xx, int yy)
{
    printf("%d %d %d %d\n", x, y, xx, yy);
    exit(0);
}

void solve(int x, int y)
{
    int i, cnt = 0;

    H[y] = true; ne = 0;
    FOR (i, 1, N)
    {
        E[ne].x = A[i].x-x;
        E[ne].y = A[i].y1-y;
        E[ne++].sgn = +1;

        E[ne].x = A[i].x-x;
        E[ne].y = A[i].y2-y;
        E[ne++].sgn = -1;
    }

    sort(E, E+ne);

    FOR (i, 0, ne)
    {
        cnt += E[i].sgn;
        if (cnt == N-1) dump(x, y, E[i].x+x, E[i].y+y);
    }
}

int main(void)
{
    int i, Y;
    
    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    scanf("%d\n", &N);
    FOR (i, 0, N)
    {
        fgets(buf, MAX_BUF, stdin); p = buf;
        A[i].x = get(); A[i].y1 = get(); A[i].y2 = get();
	if (A[i].x < A[0].x) swap(A[0], A[i]);
    }

//    sort(A, A+N);
    solve(A[0].x, A[0].y1);
    solve(A[0].x, A[0].y2);
    solve(A[0].x, (A[0].y1+A[0].y2)>>1);
    while (1)
    {
        do Y = A[0].y1+rand()%(A[0].y2-A[0].y1+1); while (H[Y]);
        solve(A[0].x, Y);
    }
    
    return 0;
}
