#include <stdio.h>
#include <stdlib.h>

#define MAX_N 128
#define MAX_LEN 1024
#define FIN "perfect.in"
#define FOUT "perfect.out"
#define BASE 10000
#define FOR(i, a, b) for (i = (a); i < (b); i++)

int N, F[MAX_N][MAX_LEN];
char ch;

void add(int a[], int b[])
{
    int i, t = 0;

    for (i = 1; i <= a[0] || i <= b[0] || t; i++, t /= BASE)
        a[i] = (t += a[i]+b[i]) % BASE;
    a[0] = i-1;
}

void shl(int a[])
{
    int i, t = 0;

    for (i = 1; i <= a[0] || t; i++, t /= BASE)
        a[i] = (t += a[i]<<1) % BASE;
    a[0] = i-1;
}

void mul(int a[], int b[], int c[])
{
    int i, j, t = 0;

    for (i = 1; i <= a[0]; i++)
    {
        for (t = 0, j = 1; j <= b[0] || t; j++, t /= BASE)
            c[i+j-1] = (t += c[i+j-1] + a[i]*b[j]) % BASE;
        if (c[0] < i+j-2) c[0] = i+j-2;
    }
}

void output(int a[])
{
    int i;
    
    printf("%d", a[a[0]]);
    for (i = a[0]-1; i > 0; i--)
        printf("%04d", a[i]);
    putchar('\n');
    exit(0);
}

int main(void)
{
    int i;
    
    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    scanf("%c %d\n", &ch, &N);
    if (ch == 'A' || ch == 'B')
    {
        F[0][0] = F[0][1] = F[1][0] = F[1][1] = 1;
        FOR (i, 2, N+2)
        {
            add(F[i], F[i-1]);
            add(F[i], F[i-2]);
        }
    }

    if (ch == 'A')
       output(F[N]);
    if (ch == 'B')
    {
        N++;
        mul(F[N], F[N-2], F[N+1]);
        if (N >= 3) mul(F[N-2], F[N-3], F[N+2]);
        add(F[N+1], F[N+2]);
        output(F[N+1]);
    }
    if (ch == 'C')
    {
        N = N*(N+1)/2;
        F[0][0] = F[0][1] = 1;
        FOR (i, 1, N+1) shl(F[0]);
        output(F[0]);
    }

    return 0;
}
