#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define FIN "import.in"
#define FOUT "import.out"

#define MAX_N 222

int S[MAX_N], *G[MAX_N], deg[MAX_N], E[MAX_N][2], F[MAX_N], U[MAX_N];

void DFS(int n, int f)
{
    int *p = G[n];
    for (; *p; p++)
        if (f != *p) DFS(*p, n), F[*p] = n;
}

void fill(int X, int Y, int P, int C)
{
    int sum = 0, *p, q;

    for (q = X; q != 1; sum += S[q], q = F[q]) ;
    for (q = Y; q != 1; sum += S[q], q = F[q]) ;
    sum += S[1];
    if (C && sum < P) return;
    if ((!C) && sum >= P) return;
    P -= C, sum -= P;
    if ((!U[X]) && (!U[Y]))
    {
        int t = rand() % 2;
        if (t)
        {
            S[X] -= sum, U[X] = 1;
            for (p = G[X]; *p; p++)
                if (*p != F[X]) S[*p] += sum;
        }
        else
        {
            S[Y] -= sum, U[Y] = 1;
            for (p = G[Y]; *p; p++)
                if (*p != F[Y]) S[*p] += sum;
        }
        return;
    }
    else
    if (!U[X])
    {
        S[X] -= sum, U[X] = 1;
        for (p = G[X]; *p; p++)
            if (*p != F[X]) S[*p] += sum;
    }
    else
    if (!U[Y])
    {
        S[Y] -= sum, U[Y] = 1;
        for (p = G[Y]; *p; p++)
            if (*p != F[Y]) S[*p] += sum;
    }
    else
    {
        int t = rand() % 2;
        if (t) S[X] -= sum;
        else S[Y] -= sum;
    }
}

int main(void)
{
    int i, X, Y, P, C, N, M, K;

    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    srand(0);

    scanf("%d %d %d", &N, &M, &K);
    memset(deg, 0, sizeof(deg));
    for (i = 1; i < N; i++)
    {
        scanf("%d %d", E[i], E[i] + 1);
        deg[E[i][0]]++, deg[E[i][1]]++;
    }
    for (i = 1; i <= N; i++) G[i] = malloc(sizeof(int) * (deg[i] + 1));
    memset(deg, 0, sizeof(deg));
    for (i = 1; i < N; i++)
    {
        G[E[i][0]][deg[E[i][0]]++] = E[i][1];
        G[E[i][1]][deg[E[i][1]]++] = E[i][0];
    }
    for (i = 1; i <= N; i++) G[i][deg[i]] = 0;
    
    DFS(1, 0);

    memset(S, 0, sizeof(S));
    memset(U, 0, sizeof(U));
    while (M--)
    {
        scanf("%d %d %d %d", &X, &Y, &P, &C);
        fill(X, Y, P, C);
    }

    for (i = 1; i <= N; i++)
        printf("%d ", S[i]);
    
    return 0;
}
