#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>

#define FIN "oypara.in"
#define FOUT "oypara.out"

#define MAX_L 1000
#define MAX_N 100000

typedef struct
{
    int x, y1, y2;
} VSegment;
typedef struct
{
    int x1, x2, y1, y2;
} Segment;
typedef struct
{
    int x, y;
} Point;

int N;
Point P[200];
VSegment *a, *b, A[MAX_N];

inline int cmp(const void *i, const void *j)
{
    a = (VSegment *) i, b = (VSegment *) j;
    
    if (a->x == b->x)
        if (a->y1 == b->y1) return b->y2 - a->y2;
        else return a->y1 - b->y1;
    return a->x - b->x;
}

inline void swap(int *a, int *b)
{
    const int tmp = *a;
    *a = *b, *b = tmp;
}

inline int lower(VSegment X, Segment upp)
{
    if (X.y2 < upp.y1) return 1;
    if (X.y2 > upp.y2) return 0;
    return (X.y2 - upp.y1) * (upp.x2 - X.x) > (upp.y2 - X.y2) * (X.x - upp.x1);
}

inline int upper(VSegment X, Segment low)
{
    if (X.y1 > low.y2) return 1;
    if (X.y1 < low.y1) return 0;
    return (low.x2 - X.x) * (X.y1 - low.y1) > (X.x - low.x1) * (low.y2 - X.y1);
}

inline int sgn(int t)
{
    return t > 0 ? 1 : -1;
}

inline void line_eq(int x1, int y1, int x2, int y2, int *a, int *b, int *c)
{
    *a = y2 - y1;
    *b = x1 - x2;
    *c = (x2 - x1) * y1 - (y2 - y1) * x1;
}

int works(int x1, int y1, int x2, int y2)
{
    int i, a, b, c, t1, t2;

    line_eq(x1, y1, x2, y2, &a, &b, &c);
    for (i = 0; i < N; i++)
    {
        t1 = a * A[i].x + b * A[i].y1 + c;
        t2 = a * A[i].x + b * A[i].y2 + c;
        if ((!t1) || (!t2)) continue;
        if (sgn(t1) == sgn(t2)) return 0;
    }
    return 1;
}

void do_brute(void)
{
    int i, j, n = 0;

    for (i = 0; i < N; i++)
    {
        P[n].x = A[i].x, P[n++].y = A[i].y1;
        P[n].x = A[i].x, P[n++].y = A[i].y2;
    }

    for (i = 0; i < n; i++)
        for (j = i + 1 + (1 - (i & 2)); j < n; j++)
            if ((P[i].x != P[j].x || P[i].y != P[j].y) && works(P[i].x, P[i].y, P[j].x, P[j].y)) goto write;
    write: printf("%d %d %d %d\n", P[i].x, P[i].y, P[j].x, P[j].y);
}

char *parse(char *p, int *v)
{
    int n = 0;

    for (; *p && !isdigit(*p); p++) ;
    for (; *p && isdigit(*p); p++) n = (n * 10) + (*p) - '0';
    *v = n;
    return p;
}

int main(void)
{
    int i;
    char line[MAX_L], *p;
    Segment upp, low;

    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    scanf("%d\n", &N);
    for (i = 0; i < N; i++)
    {
        fgets(line, MAX_L, stdin), p = line;
        p = parse(p, &A[i].x);
        p = parse(p, &A[i].y1);
        p = parse(p, &A[i].y2);
        if (A[i].y1 > A[i].y2) swap(&A[i].y1, &A[i].y2);
    }
    if (N <= 150)
    {
        do_brute();
        return 0;
    }

    qsort(A, N, sizeof(VSegment), cmp);

    upp.x1 = A[0].x, upp.y1 = A[0].y1, upp.x2 = A[1].x, upp.y2 = A[1].y2;
    low.x1 = A[0].x, low.y1 = A[0].y2, low.x2 = A[1].x, low.y2 = A[i].y1;
    for (i = 2; i < N; i++)
    {
        if (lower(A[i], upp)) upp.x2 = A[i].x, upp.y2 = A[i].y2;
        if (upper(A[i], low)) low.x2 = A[i].x, low.y2 = A[i].y1;
    }

    printf("%d %d %d %d\n", low.x1, low.y1, low.x2, low.y2);

    return 0;
}
