#include <stdio.h>
#include <string.h>

#define FIN "perfect.in"
#define FOUT "perfect.out"

#define MAX_D 10000

void sum(int A[], int B[], int C[])
{
    int i, t = 0;

    memset(C, 0, sizeof(int) * MAX_D);
    for (i = 1; i <= A[0] || i <= B[0] || t; i++, t /= 10)
        C[i] = (t += A[i] + B[i]) % 10;
    C[0] = i - 1;
}

void typeA(int N, int V[])
{
    int S[3][MAX_D], a, b, c, i;

    memset(V, 0, sizeof(int) * MAX_D);
    a = 0, b = 1, c = 2;
    memset(S, 0, sizeof(S));
    S[a][0] = S[a][1] = 1;
    S[b][0] = 1, S[b][1] = 2;
    if (N <= 2)
    {
        if (N == 1) memcpy(V, S[a], sizeof(int) * MAX_D);
        if (N == 2) memcpy(V, S[b], sizeof(int) * MAX_D);
        return;
    }
    for (i = 3; i <= N; i++, a = (a + 1) % 3, b = (b + 1) % 3, c = (c + 1) % 3)
        sum(S[a], S[b], S[c]);
    memcpy(V, S[b], sizeof(int) * MAX_D);
}

void mul(int A[], int B[], int C[])
{
    int i, j, t;

    memset(C, 0, sizeof(int) * MAX_D);
    for (i = 1; i <= A[0]; i++)
    {
        for (j = 1, t = 0; j <= B[0] || t; j++, t /= 10)
            C[i + j - 1] = (t += A[i] * B[j] + C[i + j - 1]) % 10;
        if (i + j - 2 > C[0]) C[0] = i + j - 2;
    }
}

void muls(int A[], int m, int V[])
{
    int i, t = 0;

    memset(V, 0, sizeof(int) * MAX_D);
    for (i = 1; i <= A[0] || t; i++, t /= 10)
        V[i] = (t += A[i] * m) % 10;
    V[0] = i - 1;
}

void typeB(int N, int V[])
{
    int A[MAX_D], B[MAX_D], C[MAX_D];

    if (N == 3)
    {
        memset(V, 0, sizeof(V));
        V[0] = 1, V[1] = 6;
        return;
    }
    if (N > 2)
    {
        typeA(N, A);
        typeB(N - 1, B);
        mul(A, B, V);
    }
    else
    {
        if (N == 2) { memset(V, 0, sizeof(int) * MAX_D); V[0] = 1, V[1] = 4; }
        else { memset(V, 0, sizeof(int) * MAX_D); V[0] = 1, V[1] = 2; }
    }
}

void write(int V[])
{
    int i;
    for (i = V[0]; i; i--) printf("%d", V[i]);
}

int main(void)
{
    char T;
    int N, V[MAX_D];

    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    scanf("%[ABC] %d", &T, &N);

    switch (T)
    {
        case 'A': typeA(N, V); break;
        case 'B': typeB(N, V); break;
    //    case 'C': typeC(N); break;
    }

    write(V);

    return 0;
}
