#include <cstdio>
#include <cstdlib>
#include <cstring>

#define NMAX 105
#define HMAX 128
#define BASE 10000

typedef int BigNum[HMAX];

void Add(int A[], int B[], int C[])
{
    int T = 0, i;
    memset(C, 0, sizeof(BigNum));
    for (i = 1; i <= A[0] || i <= B[0] || T; i ++, T /= BASE)
        C[i] = (T += A[i] + B[i]) % BASE;
    C[0] = i - 1;
}

void Mult(int A[], int B[], int C[])
{
    int T, i, j;
    memset(C, 0, sizeof(BigNum));
    for (i = 1; i <= A[0]; i ++)
    {
        for (T = 0, j = 1; j <= B[0] || T; j ++, T /= BASE)
            C[i + j - 1] = (T += (C[i + j - 1] + A[i] * B[j])) % BASE;
        if (i + j - 2 > C[0])
            C[0] = i + j - 2;
    }
}

void dub(int A[])
{
    int i, T = 0;
    for (i = 1; i <= A[0] || T; i ++, T /= BASE)
        A[i] = (T += 2 * A[i]) % BASE;
    A[0] = i - 1;
}

void Set(int A[], int x)
{
    memset(A, 0, sizeof(BigNum));
    for (; x > 0; x /= BASE)
        A[++ A[0]] = x % BASE;
}

void show(int A[])
{
    int i;
    printf("%d", A[A[0]]);
    for (i = A[0] - 1; i >= 1; i --)
        printf("%04d", A[i]);
    printf("\n");
}

BigNum A[NMAX], B[NMAX], C[NMAX];
int N, i, j;
char Op;


int main(void)
{
    freopen("perfect.in", "r", stdin);
    freopen("perfect.out", "w", stdout);
    do {
        scanf("%c", &Op);
    } while (Op != 'A' && Op != 'B' && Op != 'C');
    scanf("%d", &N);

    Set(A[1], 1);
    Set(A[2], 2);
    for (i = 3; i <= N; i ++)
        Add(A[i - 1], A[i - 2], A[i]);

    if (Op == 'A')
    {
        show(A[N]);
        return 0;
    }

    Set(B[1], 2);
    Set(B[2], 4);

    for (i = 3; i <= N; i ++)
    {
        BigNum X, Y;
        Mult(A[i - 1], A[i - 1], X);
        Mult(A[i - 2], A[i - 2], Y);
        Add(X, Y, B[i]);
        //dublez B[i]
        dub(B[i]);
    }

    if (Op == 'B')
    {
        show(B[N]);
        return 0;
    }

    Set(C[1], 2);
    Set(C[2], 8);
    //calculeaza C

    show(C[N]);
    return 0;
}
