using namespace std;

#include <cstdio>
#include <vector>
#include <algorithm>

#define FIN  "oypara.in"
#define FOUT "oypara.out"

#define MAX_N  100010
#define point pair<int, int>
#define x first
#define y second

int N;
point Sa, Sb;

point up[MAX_N], down[MAX_N];

void read()
{
	int i;
	int x1, y1, y2;
	FILE *fi = fopen(FIN, "r");
	fscanf(fi, "%d", &N);
	for (i = 0; i < N; ++i) {
		fscanf(fi, "%d%d%d", &x1, &y1, &y2);
		down[i] = make_pair(x1, y1);
		up[i] = make_pair(x1, y2);
	}

	down[N] = make_pair(100000000, 0);
	up[N++] = make_pair(100000000, 100000000);
	
	fclose(fi);
}

int up_cmp(const point &a, const point &b)
{
	if (a.x == b.x)
		return a.y > b.y;
	return a.x < b.x;
}

int dstk[MAX_N], dss;
int ustk[MAX_N], uss;

typedef long long ll;

int cross_p(point A, point B, point C)
{
	ll t = (ll)(A.x-B.x)*(C.y-B.y)-(ll)(C.x-B.x)*(A.y-B.y);
	return t < 0 ? -1 : t > 0 ? +1 : 0;
}

int intersect(point A, point B, point C, point D)
{
	// AB cu CD
	return cross_p(A, C, B)*cross_p(A, D, B) != 1;
}

point tmp[MAX_N];

void solve()
{
	int i, j;
	sort(down, down+N);
	sort(up, up+N, up_cmp);
	for (i = 0; i < N; ++i) {
		while (dss >= 2 && cross_p(down[dstk[dss-2]], down[dstk[dss-1]], 
					down[i]) <= 0)
			dss--;
		dstk[dss++] = i;

		while (uss >= 2 && cross_p(up[ustk[uss-2]], up[ustk[uss-1]],
					up[i]) >= 0)
			uss--;
		ustk[uss++] = i;
	}
	for (i = 0; i < dss; ++i)
		tmp[i] = down[dstk[i]];
	memcpy(down, tmp, sizeof(down));
	
	for (i = 0; i < uss; ++i)
		tmp[i] = up[ustk[i]];
	memcpy(up, tmp, sizeof(up));
	
	for (j = 0; j+1 < uss; ++j)
		if (intersect(down[0], down[1], up[j], up[j+1]))
			break;
	if (j+1 == uss) {
		Sa = down[0], Sb = down[1];
	}
	for (i = 1; i+1 < dss; ++i) {
		while (j+1 != uss && !intersect(down[i], down[i+1], up[j], up[j+1]))
			j++;
		if (j+1 == uss) {
			Sa = down[i], Sb = down[i+1];
			break;
		}
	}
}

void write()
{
	FILE *fo = fopen(FOUT, "w");
	fprintf(fo, "%d %d %d %d\n", Sa.x, Sa.y, Sb.x, Sb.y);
	fclose(fo);
}

int main()
{
	read();
	solve();
	write();
	return 0;
}
