using namespace std;

#include <cstdio>
#include <cstring>

#define FIN  "perfect.in"
#define FOUT "perfect.out"

#define MAX_N 128

#define RDX 10000
#define FMT "%04d"
#define LEN 200

char tp[16];
int N;
int A[MAX_N][LEN], ans[5000];

void read()
{
	FILE *fi = fopen(FIN, "r");
	fscanf(fi, "%s%d", &tp, &N);
	fclose(fi);
}

void print(int A[], FILE *f)
{
	int i;
	fprintf(f, "%d", A[A[0]]);
	for (i = A[0]-1; i > 0; --i)
		fprintf(f, FMT, A[i]);
	fprintf(f, "\n");
}

void add(int A[], int B[])
{
	int i, t;
	for (t = 0, i = 1; i <= A[0] || i <= B[0] || t; ++i, t /= RDX)
		A[i] = (t += A[i]+B[i])%RDX;
	A[0] = i-1;
}

void add1(int A[])
{
	int i;
	for (i = 1; i <= A[0] && A[i]+1 == RDX; A[i++] = 0);
	A[i]++;
	if (i > A[0])
		A[0] = i;
}

void mult(int A[], int X)
{
	int i, t;
	for (t = 0, i = 1; i <= A[0] || t; ++i, t /= RDX)
		A[i] = (t += A[i]*X)%RDX;
	A[0]=i-1;
}

void mult_big(int A[], int B[], int C[])
{
	int i, j, t;
	for (i = 1; i <= A[0]; ++i) {
		for (t = 0, j = 1; j <= B[0] || t; ++j, t /= RDX)
			C[i+j-1] = (t += C[i+j-1]+A[i]*B[j])%RDX;
		if (C[0] < i+j-2)
			C[0] = i+j-2;
	}
}

void solve()
{
	int i, j;
	int P[5000];
	if (!strcmp(tp, "C")) {
		ans[0] = ans[1] = 1;
		int e = N*(N+1)/2;
		for (; e >= 15; e -= 15)
			mult(ans, 1<<15);
		for (; e; e--)
			mult(ans, 2);
	} else {
		A[0][0] = A[0][1] = A[1][0] = A[1][1] = 1;
		for (i = 2; i <= N; ++i) {
			for (j = 0; i-2*j-1 >= 0; ++j) {
				add(A[i], A[i-2*j-1]);
			}
			if (i%2 == 0)
				add1(A[i]);
		}
		if (!strcmp(tp, "A")) {
			memcpy(ans, A[N], sizeof(A[N]));
		} else { // "B"
			memset(ans, 0, sizeof(ans));
			mult_big(A[N-1], A[N-1], ans);
			if (N >= 2) {
				memset(P, 0, sizeof(P));
				mult_big(A[N-1], A[N-2], P);
				add(ans, P);
				mult(ans, 2);
			}
		}
	}
}

void write()
{
	FILE *fo = fopen(FOUT, "w");
	print(ans, fo);
	fclose(fo);
}

int main()
{
	read();
	solve();
	write();
	return 0;
}
