//solutie cu liste de vecini - O(n) 
//bluel = vector de frunze albastre
//B = vector cu noduri albastre
//db = cel mai adanc (deci apropiat) nod albastru pentru funza i
//dg = vector de grade (pt det frunze)
//t = vectorul de tati plecand din radacina
//tp = vector de tati plecand dintr-un nod oarecare
//m = vector de muchii
#include<stdio.h>
# define nmax 1001
struct muchie {long vf; int cost,cul;};
struct muchie m[nmax];
int n,k,i,r,mx,x,j,b,l,delta,cost,v,poz;
int bluel[nmax],B[nmax],db[nmax],dg[nmax],viz[nmax],t[nmax],tp[nmax];
int a[nmax][nmax];

void citeste(void)
{ int v1,v2,cost,temp;
  FILE * fi;
  fi = fopen("camion.in","rt");
  fscanf(fi,"%d%d",&n,&k);
  for (j=1;j<=n-1;j++)
   { fscanf(fi,"%d%d%d",&v1,&v2,&cost);
     if (v1>v2) {temp=v1;v1=v2;v2=temp;}
     a[v1][dg[v1]]=v2; a[v2][dg[v2]]=v1; dg[v1]++; dg[v2]++;
     m[j].cost = cost;
     m[j].vf = n*v1+v2;
   }
}
int part(int st, int dr)
{ int i=st,j=dr,s=1;
  while (i<j)
   { if (m[i].vf>m[j].vf)
      {struct  muchie temp = m[i]; m[i]=m[j]; m[j]=temp; s=-s;}
     if (s==1) i++;
       else j--;
   }
  return i;
}

void qsort(int st, int dr)
{ int p;
  if (st<dr)
   { p = part(st,dr);
     qsort(st,p-1);
     qsort(p+1,dr);
    }
}

void parc(int v)
{ int j,vecin;
  viz[v]=1;
  for (j=0;j<dg[v];j++)
   {vecin=a[v][j];
    if(vecin!=0 && viz[vecin]==0)
      { tp[vecin]=v;
	parc(vecin);
      }
    }
}
int find(int v1, int v2)
{ int st=1, dr=n-1,mj,val;
  if (v1>v2) {int temp=v1;v1=v2;v2=temp;}
  val = v1*n + v2;
  do
  { mj = (st+dr)/2;
    if (m[mj].vf == val)
      return mj;
    if (m[mj].vf > val)
      dr = mj-1;
    else
      st = mj+1;
   }
   while (st<=dr);
   printf("upsi!!");
   return 0;
}

int difpathw(int r, int v1, int v2)   	//costul caii de la v1 la v2
{ int cost1=0,cost2=0,v,j,poz;
  for (j=1;j<=n;j++) tp[j]=viz[j]=0;	//det vect tati plecand din v1
  viz[v1]=1;
  parc(v1);
  v=v2;
  while (v!=v1)
   { poz = find(v,tp[v]);
     cost1 += m[poz].cost;
     v = tp[v];
   }
  v=r;
  while (v!=v1)
   { poz = find(v,tp[v]);
     cost2 += m[poz].cost;
     v = tp[v];
   }
  return cost1 - cost2;
}

void colorblue(int b, int l)	//coloreaza albastru calea b-l
{ int v=l,j,aux;
  for (j=1;j<=n;j++) tp[j]=viz[j]=0;	//det vect tati plecand din v1
  viz[b]=1;
  if (t[b]!=0)
   { for (j=0;j<dg[b];j++)
      if (a[b][j]==t[b])
       { aux = j;		//memorez pozitia tatalui in lista de vecini
	 a[b][j] = 0 ;		//rup legatura lui b in sus
	 break;			//ca sa lucrez numai pe subarborele lui b
       }
    }
  parc(b);			//colorez in blue vf de pe calea b-l
  while (v!=b)
   { B[v]=1;
     v= tp[v];
    }
  for (j=1;j<=n;j++)
    if (dg[j]==1 && tp[j]!=0 )	//iau frunzele din subarb(b)
      { v = j;
	while (B[v]!=1)		//cat nu dau de albastru
	  v = tp[v];
	db[j]=v;		//retin cel mai adanc vf albastru pt frunza j
      }
  if (t[b]!=0)
     a[b][aux]=t[b];		//refac legatura lui b in sus
}

int main()
{ FILE * fo;
  citeste();	//citeste datele din fis text
  qsort(1,n-1);
  r = 1;
  viz[r]=1;
  parc(r);	//calc vectorul de tati t (plecare din radacina)
  for (j=1;j<=n;j++)
    t[j]=tp[j];
  B[1]=1;	//radacina e 1 si e albastra
  for (j=1;j<=n;j++)
    if (dg[j]==1)
      db[j]=r;
  i=0;
  do
  { i++;
    mx = 0;
    for (x=1;x<=n;x++)
      if (dg[x]==1 && B[x]==0)
       { delta = difpathw(r,db[x],x);
	 if (delta > mx)
	   { mx = delta;
	     l = x;
	   }
       }
    if (mx<=0) {i--;break;}
    b = db[l];
    bluel[i]=l;
    colorblue(b,l);	//coloreaza varfurile din calea b-l in albastru si
			//update db pentru frunzele din subarborele lui b
  }
  while (i<k);
  fo = fopen("camion.out","wt");
/*  fprintf(fo,"%d\n",i);
  for (j=1;j<=i;j++)
      fprintf(fo,"%d ",bluel[j]);
  printf("\n");
*/
  cost = 0;
  for (j=1;j<=i;j++)
  { v=bluel[j];
    while (v!=r)
    { poz = find(v,t[v]);
      cost += m[poz].cost;
      m[poz].cul=1;
      v = t[v];
    }
  }
  for (j=1;j<=n-1;j++)
    if (m[j].cul==0)
      cost += 2*m[j].cost;
  fprintf(fo,"%d\n",cost);
  return 0;
}

